unsigned int ntqpfm_copy(const char *src, char *dst,
                int len, int sum, int *src_err_ptr, int *dst_err_ptr)
{
	char xmm0[16];
	__asm__ __volatile__ (
		"	"PREFETCH" (%0)\n"
		"	"PREFETCH" 64(%0)\n"
		"	"PREFETCH" 128(%0)\n"
		"	"PREFETCH" 192(%0)\n"
			: : "r" (src)
	);
	__asm__ __volatile__ (
		"	movups	%%xmm0, %0\n"
			: /* output */ "=m"(xmm0[0])
	);

	int count = len/(8*8);
	while(count--) {
		__asm__ __volatile__ (
		"1:	"PREFETCH" 256(%1)\n"
		"	xorl	%%ecx, %%ecx\n"	//carry unset - we need it
		"	mov	$4, %%cl\n"
		"2:	movups	(%1), %%xmm0\n"
		"	adcl	(%1), %%eax\n"
		"	adcl	4(%1), %%eax\n"
		"	adcl	8(%1), %%eax\n"
		"	adcl	12(%1), %%eax\n"
		"	movups	%%xmm0, (%2)\n"
		"	leal	16(%1), %1\n"
		"	leal	16(%2), %2\n"
		"	loop	2b\n"
		"	adcl	$0, %%eax\n"
			: /* output */	"=a" (sum)
			: /* input */	"r" (src), "r" (dst), "a" (sum)
			: /* clobber */	"bx", "cx", "memory"
		);
	}
	__asm__ __volatile__ (
			FEMMS
			SFENCE
		"	movups	%0, %%xmm0\n"
			: : /* input */ "m"(xmm0[0])
	);

	return sum;
}
